%% ##include tactic.copyright##

%% try applying Tac to each current proof node.
tactic many(Tac) ===
  %%trace;
  !(    zero 
    '|'
        [!(one;Tac '|' one), many(Tac)]
   ).

%% try applying Tac to each current proof node, then try applying deep(Tac) 
%% on each successful result.
tactic deep(Tac) ===
  trace;
  !(    zero
    '|' 
        [!(one;Tac;deep(Tac) '|' one), deep(Tac)]
   );
  trace.

%% apply Tac to each current proof node.
tactic all( Tac ) ===
(   zero
    '|'
    [   one; Tac
    ,   all( Tac )
    ]
).

